# SourcePath: glibc-2.25/20190619
Summary: Embedded Glibc.
Name: sony-target-dev-glibc
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-glibc
Version: 2.25
Release: 14010005
License: LGPL2.1 / Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.glibc.org/home
Source0: glibc-%{version}.tar.xz

## LOT script Files
Source10: sony-devel-libopt-build-libc
Source11: sony-devel-libopt-build-libcrypt
Source12: sony-devel-libopt-build-libdl
Source13: sony-devel-libopt-build-libm
Source14: sony-devel-libopt-build-libpthread
Source15: sony-devel-libopt-build-librt

Patch001: 0009-Quote-from-bug-1443-which-explains-what-the-patch-do.patch
Patch002: 0012-Make-ld-version-output-matching-grok-gold-s-output.patch
Patch003: 0013-sysdeps-gnu-configure.ac-handle-correctly-libc_cv_ro.patch
Patch004: 0014-Add-unused-attribute.patch
Patch005: 0015-yes-within-the-path-sets-wrong-config-variables.patch
Patch006: 0016-timezone-re-written-tzselect-as-posix-sh.patch
Patch007: 0017-Remove-bash-dependency-for-nscd-init-script.patch
Patch008: 0018-eglibc-Cross-building-and-testing-instructions.patch
Patch009: 0020-eglibc-Help-bootstrap-cross-toolchain.patch
Patch010: 0024-eglibc-Forward-port-cross-locale-generation-support.patch
#Patch100: glibc-2.11.2-localedef_segfault-1.patch
Patch101: glibc-2.11.2-arm-longjmp_chk-unwinding-support.patch
Patch102: glibc-ports-2.11-mcount_gprof_fix.patch
#Patch103: glibc-2.11.2-rtld-osinfo-nonfatal.patch
Patch104: glibc-2.11.2-hp-timing-ctors.patch
#Patch105: glibc-2.11.2-nptl-cond_timedwait_rel.patch
Patch106: 0029-bits-siginfo.h-enum-definition-for-TRAP_HWBKPT-is-mi.patch
Patch107: glibc-2.25-CVE-2017-12132.patch
Patch108: glibc-2.25-CVE-2017-12133.patch
Patch109: glibc-2.25-CVE-2017-15670.patch
Patch110: glibc-2.25-CVE-2017-15671.patch
Patch111: glibc-2.25-CVE-2017-15804.patch
Patch112: glibc-2.25-CVE-2017-16997.patch
Patch113: glibc-2.25-CVE-2017-1000366.patch
Patch114: glibc-2.25-CVE-2018-6485-6551.patch
Patch115: glibc-2.25-CVE-2018-11236.patch
Patch116: glibc-2.25-CVE-2018-1000001.patch
Patch117: glibc-2.25-CVE-2019-9169.patch
Patch118: glibc-2.25-CVE-2020-1752.patch
Patch119: glibc-2.25-CVE-2020-6096_1.patch
Patch120: glibc-2.25-CVE-2020-6096_2.patch
BuildRoot: %{_tmppath}/%{name}-root
#Prefix: %{sony_cross_target_dir}
Prefix: %{sony_target_dir}

BuildRequires: %{sony_tool_triplet}-cross-libopt-for-dev

%description
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%package -n %{pkgname}
Summary: The GNU C Library.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%prep
%setup -q -n glibc-%{version}

# Apply patches
%patch001 -p1
%patch002 -p1
%patch003 -p1
%patch004 -p1
%patch005 -p1
%patch006 -p1
%patch007 -p1
%patch008 -p1
%patch009 -p1
%patch010 -p1
#%patch100 -p1
%patch101 -p1
%patch102 -p1
#%patch103 -p1
%patch104 -p1
#%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%build
%sony_target_dev_setup

%define _header_dir %{sony_target_dir}%{sony_target_dev_include_dir}

export CFLAGS="-O2 -g"

# autoconf cause "checking for grep that handles long lines and -e"
# failure, config.log msg: error: no acceptable grep could be found
#autoconf &&
%if "%{sony_target_cpu}" == "ppc"
   export libc_cv_ppc_machine=yes \
	  libc_cv_ppc_rel16=no \
%endif
# to build nptl
export libc_cv_forced_unwind=yes
export libc_cv_c_cleanup=yes
export libc_cv_gnu99_inline=yes

export BUILD_CC="gcc"
%sony_target_dev_configure \
	--disable-sanity-checks \
	--enable-kernel=3.4.0 \
        --enable-obsolete-rpc \
	--enable-profile \
	--without-cvs \
%if "%{sony_target_fpu}" == "no"
	--without-fp \
%endif
	--with-tls \
	--with-__thread \
	--without-gd \
	--with-headers=%{_header_dir} &&
cat <<EOF > configparms &&
slibdir=%{sony_target_dev_dir}/lib
libdir=%{sony_target_dev_prefix}/lib
sysconfdir=%{sony_target_dev_dir}/etc
EOF
make OBJDUMP_FOR_HOST=%{sony_target_toolprefix}objdump all

%install
%sony_target_dev_setup

rm -rf %{buildroot}

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libc
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libcrypt
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libdl
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libm
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libpthread
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/librt

cd %{sony_objdir} &&
make \
    install_root=%{buildroot}%{sony_target_dir} \
    OBJDUMP_FOR_HOST=%{sony_target_toolprefix}objdump \
    install

# NPTL <bits/stdio-lock.h> is not usable outside of glibc, so include
# the generic one (#162634)
#cp -a ../bits/stdio-lock.h  %{buildroot}%{_header_dir}/bits/stdio-lock.h

# Fix ld scripts (remove '/devel/lib/' and '/devel/usr/lib/').
for f in /usr/lib/libc.so /usr/lib/libpthread.so
do
    sed -e 's,%{sony_target_dev_dir}/[^ 	]*/,,g' \
	-e '/BUG in libc.scripts.output-format.sed/d' \
        %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}$f > tmp.so
    mv -f tmp.so %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}$f
done

## Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
OBJECTDIR=`/bin/pwd`

## Install Library Optimizer information (libc)
install -m 755 %{SOURCE10} %{_optdir}/libc/build
install -m 644 libc.map %{_optdir}/libc/libc.map
install -m 644 shlib.lds %{_optdir}/libc/libc.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libc/abi-note.o
install -m 644 elf/soinit.os %{_optdir}/libc/soinit.o
install -m 644 elf/sofini.os %{_optdir}/libc/sofini.o
install -m 644 elf/interp.os %{_optdir}/libc/interp.o
(cd %{_optdir}/libc; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/libc_pic.a)
(cd %{_optdir}/libc; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/libc.so -r *.o -o *.os > index)
(umask 022; echo "/lib/libc-"%{version}".so" > %{_optdir}/libc/path)

## Install Library Optimizer information (libcrypt)
install -m 755 %{SOURCE11} %{_optdir}/libcrypt/build
install -m 644 libcrypt.map %{_optdir}/libcrypt/libcrypt.map
install -m 644 shlib.lds %{_optdir}/libcrypt/libcrypt.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libcrypt/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libcrypt/interp.o
(cd %{_optdir}/libcrypt; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/crypt/libcrypt_pic.a)
(cd %{_optdir}/libcrypt; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/crypt/libcrypt.so -r *.o -o *.os > index)
(umask 022; echo "/lib/libcrypt-"%{version}".so" > %{_optdir}/libcrypt/path)

## Install Library Optimizer information (libdl)
install -m 755 %{SOURCE12} %{_optdir}/libdl/build
install -m 644 libdl.map %{_optdir}/libdl/libdl.map
install -m 644 shlib.lds %{_optdir}/libdl/libdl.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libdl/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libdl/interp.o
(cd %{_optdir}/libdl; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/dlfcn/libdl_pic.a)
(cd %{_optdir}/libdl; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/dlfcn/libdl.so -r *.o -o *.os > index)
(umask 022; echo "/lib/libdl-"%{version}".so" > %{_optdir}/libdl/path)

## Install Library Optimizer information (libm)
install -m 755 %{SOURCE13} %{_optdir}/libm/build
install -m 644 libm.map %{_optdir}/libm/libm.map
install -m 644 shlib.lds %{_optdir}/libm/libm.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libm/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libm/interp.o
(cd %{_optdir}/libm; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/math/libm_pic.a)
(cd %{_optdir}/libm; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/math/libm.so -r *.o -o *.os > index)
(umask 022; echo "/lib/libm-"%{version}".so" > %{_optdir}/libm/path)

## Install Library Optimizer information (libpthread)
install -m 755 %{SOURCE14} %{_optdir}/libpthread/build
install -m 644 libpthread.map %{_optdir}/libpthread/libpthread.map
install -m 644 shlib.lds %{_optdir}/libpthread/libpthread.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libpthread/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libpthread/interp.o
install -m 644 nptl/pt-interp.os %{_optdir}/libpthread/pt-interp.o
install -m 644 nptl/crti.o %{_optdir}/libpthread/crti.o
install -m 644 nptl/crtn.o %{_optdir}/libpthread/crtn.o
(cd %{_optdir}/libpthread; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/nptl/libpthread_pic.a)
(cd %{_optdir}/libpthread; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/nptl/libpthread.so -r *.o -o *.os > index)
(umask 022; echo "/lib/libpthread-"%{version}".so" > %{_optdir}/libpthread/path)

## Install Library Optimizer information (librt)
install -m 755 %{SOURCE15} %{_optdir}/librt/build
install -m 644 librt.map %{_optdir}/librt/librt.map
install -m 644 shlib.lds %{_optdir}/librt/librt.so.lds
install -m 644 csu/abi-note.o %{_optdir}/librt/abi-note.o
install -m 644 elf/interp.os %{_optdir}/librt/interp.o
(cd %{_optdir}/librt; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/rt/librt_pic.a)
(cd %{_optdir}/librt; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/rt/librt.so -r *.o -o *.os > index)
(umask 022; echo "/lib/librt-"%{version}".so" > %{_optdir}/librt/path)

# temporary work around for gcc system header dir
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}
ln -s ..%{sony_target_dev_include_dir}\
	 %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}

# Added this for fixing the crti.o Error
#ln -s %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir} \
#	 %{sony_target_dir}%{sony_target_dev_prefix}/lib

#for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib64_dir}`; do
#    case $l in
#        *.o)
#          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}
#	  ln -s ../lib64/$l \
#		%{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
#          ;;
#    esac
#done

# 6.x
for b in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}`; do
    case $b in
        *-config)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/$b \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}`; do
    case $l in
        *.a|pkgconfig)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" ]; then
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
            %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done

# temporary work around for gcc compilation error by symlink stubs-soft.h → stubs-hard.h
#cd %{buildroot}%{sony_target_dir}/usr/include/gnu/
#ln -sf stubs-hard.h  stubs-soft.h
#cd -

# Created this symbolic link to bring up the board as kernel looks for ld-linux.so.3
#cd %{buildroot}%{sony_target_dir}/lib/
#ln -sf ld-linux-armhf.so.3  ld-linux.so.3
#cd -

# remove info on target
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/info

#rm -rf %{buildroot}%{sony_target_dir}/usr/include/
#rm -rf %{sony_target_dir}/usr/include/

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)

%{sony_target_dir}

%changelog
* Fri Feb 19 2021 Sony Corporation
- Added CVE patches glibc-2.25-CVE-2020-1752.patch, glibc-2.25-CVE-2020-6096_1.patch, glibc-2.25-CVE-2020-6096_2.patch

* Thu Jul 04 2019 Sony Corporation
- Removed Test Cases from glibc-2.25-CVE-2018-1000001.patch, glibc-2.25-CVE-2018-6485-6551.patch, glibc-2.25-CVE-2018-11236.patch.
 
* Wed Jun 19 2019 Sony Corporation
- Added fix for CVE-2017-12132, CVE-2017-12133, CVE-2017-15670, CVE-2017-15671, CVE-2017-15804, CVE-2017-16997, CVE-2017-1000366, CVE-2018-6485-6551, CVE-2018-11236, CVE-2018-1000001, CVE-2019-9169.

* Fri Dec 07 2018 Sony Corporation
- Initial build for 14.1.0.x

* Wed Nov 08 2017 Sony Corporation
- Added support for LOT in 14x

* Fri Jun 16 2017 Sony Corporation
- Updated the Version to 2.25.

* Thu Jan 12 2017 Sony Corporation
- Updated the Version to 2.22.

* Thu May 05 2016 Sony Corporation
- Added armhf support in LOT build script

* Tue Apr 19 2016 Sony Corporation
- Added work around for gcc compilation error for stubs-soft.h as part of armhf support

* Tue Feb 23 2016 Sony Corporation
- Added CVE-2015-7547 and depended patches
- Added CVE-2013-7423, CVE-2014-8121, CVE-2014-9761, CVE-2015-1472, CVE-2015-1473, CVE-2015-1781,
  CVE-2015-8776, CVE-2015-8778, CVE-2015-8779

* Mon Jul 06 2015 Sony Corporation
- Refreshed CVE patches CVE-2012-4412, CVE-2012-4424, CVE-2013-2207, CVE-2014-0475 and CVE-2014-6040

* Mon Feb 09 2015 Sony Corporation
- Added CVE-2014-7817,CVE-2014-9402 and CVE-2015-0235 fix patches

* Mon Sep 29 2014 Sony Corporation
- Added CVE-2013-0242,CVE-2013-1914,CVE-2013-4332,CVE-2012-4412,
  CVE-2013-4458,CVE-2013-2207,CVE-2014-0475,CVE-2014-5119,
  CVE-2014-6040 and CVE-2014-4043 fix patches

* Tue Oct 08 2013 Sony Corporation
- Added ld.so memory leak fix patch

* Tue Jun 25 2013 Sony Corporation
- Deleted info dir on target

* Thu Feb 28 2013 Sony Corporation
- Initial Build.
